



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[洛谷P1272] 重建道路</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[洛谷P1272] 重建道路</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-17 00:46:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>类型：树形背包</p>
<p>传送门：&gt;<a href="https://www.luogu.org/problemnew/show/P1272" rel="external nofollow noreferrer">Here</a>&lt;</p>
<blockquote><p><strong>题意：给出一棵树，要求断开$k$条边来分离出一棵有$P$个节点的子树。求最小的$k$</strong></p></blockquote>
<p>解题思路</p>
<p>和上一题类型相同，但不那么好做了&mdash;&mdash;分离出的一棵子树肯定是在一起的，不能是散的，因此这给dp带来了难度</p>
<p>$dp[u][i][j]$表示节点$u$的子树内，在前$i$棵子树内分离出有$j$个节点的子树，最少断的边。特别需要注意的是，这里的有$j$个节点的子树必须包含节点$u$</p>
<p>想到这个定义以后就不难了，有方程$$dp[u][i][j]=Min\{dp[u][i-1][j-k]+dp[v][numson[v]][k]-2\}$$相当于在前$i-1$棵子树中分离出包含$u$的大小为$j-k$的子树，并且在当前子树分离出$k$的。注意为什么要$-2$，因为这两个部分为了确保独立性，前者肯定会断掉边$(u,v)$，后者也肯定会断掉边$(u,v)$，而现在恰好需要这条边来把两棵子树连起来，因此返还2</p>
<p>一样可以滚动$$dp[u][j]=Min\{dp[u][j-k]+dp[v][k]-2\}$$</p>
<p>初始化：$dp[u][1]=u的入度$ 注意$dp[u][0]$是没有意义的，因此不作处理</p>
<p>Code</p>
<div>
<pre class="prettyprint linenums">/*By DennyQi 2018.8.14*/<br />
#include &lt;cstdio&gt;<br />
#include &lt;queue&gt;<br />
#include &lt;cstring&gt;<br />
#include &lt;algorithm&gt;<br />
#define  r  read()<br />
#define  Max(a,b)  (((a)&gt;(b)) ? (a) : (b))<br />
#define  Min(a,b)  (((a)&lt;(b)) ? (a) : (b))<br />
using namespace std;<br />
typedef long long ll;<br />
const int MAXN = ;<br />
const int MAXM = ;<br />
const int INF = ;<br />
inline int read(){<br />
    int x = ; int w = ; register int c = getchar();<br />
    while(c ^ '-' &amp;&amp; (c &lt; '' || c &gt; '')) c = getchar();<br />
    if(c == '-') w = -, c = getchar();<br />
    while(c &gt;= '' &amp;&amp; c &lt;= '') x = (x &lt;&lt; ) + (x &lt;&lt; ) + c - '', c = getchar(); return x * w;<br />
}<br />
int N,P,ans(INF),x,y,first[MAXM],nxt[MAXM],to[MAXM],cnt,dp[MAXN][MAXN],rd[MAXN];<br />
inline void add(int u, int v){<br />
    to[++cnt]=v,nxt[cnt]=first[u],first[u]=cnt;<br />
    ++rd[u], ++rd[v];<br />
}<br />
inline void DP(int u, int _f){<br />
    int v;<br />
    for(int i = first[u]; i; i = nxt[i]){<br />
        if((v=to[i]) == _f) continue;<br />
        DP(v, u);<br />
        for(int j = P; j; --j)<br />
            for(int k = ; k &lt;= j; ++k)<br />
                dp[u][j] = Min(dp[u][j], dp[u][j-k] + dp[v][k] - );<br />
    }<br />
}<br />
int main(){<br />
    memset(dp,0x3f,sizeof(dp));<br />
    N=r,P=r;<br />
    for(int i = ; i &lt; N; ++i) x=r,y=r,add(x, y);<br />
    for(int i = ; i &lt;= N; ++i) dp[i][] = rd[i];<br />
    DP(, -);<br />
    for(int i = ; i &lt;= N; ++i) ans = Min(ans, dp[i][P]);<br />
    printf("%d", ans);<br />
    return ;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39r5y2dq.html">ASP&period;NET MVC 5 - 查询Details和Delete方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/390j5338.html">map&lpar;callback&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o21l19.html">&period;NET读写Excel工具Spire&period;XlS使用（DataExport ）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p4w6z9.html">oracle中的case when then else end 用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jwzkl8.html">SpringMVC 初始化网站静态信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93em5wq.html">DALSA Coreco - 图像处理软件&lpar;Sapera LT &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1enex9.html">assert函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0e17gq.html">sencha Touch 2&period;4 学习之 XTemplate模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm4no49.html">AlarmDemo-with-Database</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmwyx69.html">根据不同ip进入不同页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1x2k39.html">&lpar;Step by Step&rpar;How to setup IP Phone Server&lpar;VoIP Server&rpar; for free&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96one5n9.html">安卓开发之viewpager学习（头条显示）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k13dn69.html">java核心技术学习笔记之一程序设计概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojpl4pq.html">03-移动端开发教程-CSS3新特性（下）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj65yk9.html">饮冰三年-人工智能-Python-26 Django 学生管理系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvvkoj8.html">&lbrack;Jenkins&rsqb;IOS构建机配置记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r53vxeq.html">&lbrack;PHP&rsqb; 链表数据结构（单链表）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy7ymx9.html">IOS 请求数据解析 XML 和 JSON</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkk0p18.html">如何通过SSH及其Client 批量分发文件和执行管理命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnromrq.html">ZOJ1586 QS Network                                                                                            2017-04-13 11&colon;46             39人阅读              评论&lpar;0&rpar;              收藏</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1r5mlz8.html">【内存溢出】Maven编译时内存溢出的问题解决方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25xd33q.html">docker安装并修改Nginx镜像</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjm0z79.html">通过 sass-resources-loader 全局注册 Sass&sol;Less 变量</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllom30q.html">动态规划-LCS最长公共子序列</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1dj1lq.html">Makes And The Product CodeForces - 817B （思维&plus;构造）</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rdmno9.html">PS打造油画般的风景人像</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjmo259.html">tomcat  one connection one thread one request one thread</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2djgrq.html">PHP优化与提升</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy247jq.html">【学亮IT手记】Servlet的生命周期</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r5jk28.html">vue的定位</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
